------ Differences with Spagic 2.0.0 ------

-- Solve SPAGIC-153 BUGS
-- IF USING SPAGIC 2.0 spagic-metadb-oracle.ddl
-- IN SPAGIC 2.1 THIS IS NOT REQUIRED
ALTER TABLE PROCESS modify process_version varchar2(20);

-- ENABLE THE PROPERTY NAME ( code ) TO BE LONG 200  
ALTER TABLE PROPERTY MODIFY code Varchar2(200);

-- Timestamp changes
ALTER TABLE process_instance MODIFY startdate Timestamp;
ALTER TABLE process_instance MODIFY enddate Timestamp;

ALTER TABLE log_journal MODIFY datelog Timestamp;

ALTER TABLE process MODIFY startdate Timestamp;
ALTER TABLE process MODIFY enddate Timestamp;

ALTER TABLE transition_instance MODIFY transition_start Timestamp;
ALTER TABLE transition_instance MODIFY transition_end Timestamp;

ALTER TABLE rule MODIFY start_date Timestamp;
ALTER TABLE rule MODIFY end_date Timestamp;


------ Differences with Spagic 2.1.0 ------

ALTER TABLE TRANSITION_INSTANCE ADD COLUMN attachment_in int DEFAULT 0;

ALTER TABLE TRANSITION_INSTANCE ADD COLUMN attachment_out int DEFAULT 0;

ALTER TABLE PROCESS ADD COLUMN monitor_enabled Char(1) NOT NULL DEFAULT 1;

ALTER TABLE TRANSITION_INSTANCE ADD transition_data_out BLOB;

------ Tables for event handling ------
Create table wait_data (
	id_wait Integer NOT NULL ,
	id_correlation Varchar2 (200) NOT NULL ,
	wait_timestamp Timestamp NOT NULL ,
	expiry_timestamp Timestamp,
	expiration_action Varchar2 (500),
	eventType Varchar2 (200) Default GenericEvent NOT NULL ,
	exchange Blob,
	signalUri Varchar2 (500),
	destinationUri Varchar2 (500),
primary key (id_wait) 
);

Create table wait_data_attribute (
	id_wait_data_attribute Integer NOT NULL ,
	id_wait Integer NOT NULL ,
	name Varchar2 (200) NOT NULL ,
	att_value Varchar2 (500),
primary key (id_wait_data_attribute) 
);

Alter table wait_data_attribute add  foreign key (id_wait) references wait_data (id_wait);

CREATE SEQUENCE seq_wait_data;

CREATE SEQUENCE seq_wait_data_attribute;

-- Exceution Time ( AZ 09/07/2008 )
ALTER TABLE transition_instance ADD COLUMN transition_execution_time Integer DEFAULT NULL;
ALTER TABLE process_instance ADD COLUMN executiontime Integer DEFAULT NULL;

-- Ricalcola tempi di esecuzione
UPDATE process_instance
SET executiontime = TIMESTAMPDIFF(SECOND,startdate,enddate) * 1000;

-- Changes for Deploy Tool
ALTER TABLE attribute ADD CONSTRAINT UNIQUE name (name);

